﻿local ME = UnitName("player")
local receiveLog = {}
local lastSoundEvent = GetTime()
local sendGroupLocker = ""

AFXConfig = {
	["On"] = true,
	["PlaySoundsGroup"] = true,
	["SendSoundsGroup"] = true,
	["CheckDistance"] = 1, -- 0 = Ignore, 1 = Inspect, 30 yards or 2 = Trade, 11.11 yards or 3 = Duel, 10 yards or 4 = Follow, ~28 yards
	["Verbose"] = false,
	["Debug"] = false,
	["MinInterval"] = 3,
}

function AFX_OnLoad()
	AFXFrame:RegisterEvent("ADDON_LOADED")
	AFX_Print(AFX_MENU.." v"..AFX_VERSION..AFX_LOADED, 1.0, 1.0, 0)
end

function AFX_OnEvent(frame, event, arg_1, arg_2, arg_3, arg_4)
	if event == "CHAT_MSG_ADDON" then
		AFX_OnChatMsgAddOn(arg_1, arg_2, arg_3, arg_4)
	elseif event == "PARTY_MEMBERS_CHANGED" then
		AFX_OnPartyMembersChanged()
	elseif event == "ADDON_LOADED" and arg_1 == "AFX" then
		SlashCmdList["AFX"] = AFX_SlashHandler
		SLASH_AFX1 = "/afx"
		SlashCmdList["AFXPLAY"] = AFX_PlaySlashHandler
		SLASH_AFXPLAY1 = "/afxplay"
		SLASH_AFXPLAY2 = "/afxp"
		SlashCmdList["AFXSEARCH"] = AFX_SearchSlashHandler
		SLASH_AFXSEARCH1 = "/afxsearch"
		SLASH_AFXSEARCH2 = "/afxs"
		AFX_Activate(AFXConfig.On)
	end
end

-- slash handler for macro and command line
-- e.g. /afxplay 1 or /afxplay Sound\Spells\PolyMorphPig.wav
function AFX_PlaySlashHandler(msg)
	AFX_Play(msg)
end

-- slash handler for macro and command line
-- e.g. /afxsearch aran
function AFX_SearchSlashHandler(msg)
	AFX_Search(msg)
end

function AFX_SlashHandler(msg)
	local words = AFX_Split(msg," ")
	if #(words) > 0 then
		local cmd = words[1]
		if cmd == "on" then
			AFX_Activate(true)
		elseif cmd == "off" then
			AFX_Activate(false)
		elseif cmd == "play" or cmd == "p" then
			if #(words) > 1 then
				local text = AFX_Strip(msg,cmd.." ")
				if text ~= nil and text ~= "" then
					AFX_Play(text)
				end
 			end
		elseif cmd == "search" or cmd == "s" then
			if #(words) > 1 then
				local text = AFX_Strip(msg,cmd.." ")
				if text ~= nil and text ~= "" then
					AFX_Search(text)
				end
 			end
		elseif cmd == "verbose" or cmd == "v" then
			local param = words[2]
			if param == "on" then
				AFXConfig.Verbose = true
				AFX_Print(AFX_LBL_VERBOSE..AFX_ON)
			elseif param == "off" then
				AFXConfig.Verbose = false
				AFX_Print(AFX_LBL_VERBOSE..AFX_OFF)
			end
		elseif cmd == "sendgroup" or cmd == "sg" then
			local param = words[2]
			if param == "on" then
				AFXConfig.SendSoundsGroup = true
				AFX_Print(AFX_LBL_SENDGROUP..AFX_ON)
			elseif param == "off" then
				AFXConfig.SendSoundsGroup = false
				AFX_Print(AFX_LBL_SENDGROUP..AFX_OFF)
			end
		elseif cmd == "playgroup" or cmd == "pg" then
			local param = words[2]
			if param == "on" then
				AFXConfig.PlaySoundsGroup = true
				AFX_Print(AFX_LBL_PLAYGROUP..AFX_ON)
			elseif param == "off" then
				AFXConfig.PlaySoundsGroup = false
				AFX_Print(AFX_LBL_PLAYGROUP..AFX_OFF)
			end
		elseif cmd == "playgroup" or cmd == "pg" then
			local param = words[2]
			if param == "on" then
				AFXConfig.PlaySoundsGroup = true
				AFX_Print(AFX_LBL_PLAYGROUP..AFX_ON)
			elseif param == "off" then
				AFXConfig.PlaySoundsGroup = false
				AFX_Print(AFX_LBL_PLAYGROUP..AFX_OFF)
			end
		elseif cmd == "quiet" or cmd == "q" then
			local param = words[2]
			if param == "on" then
				AFX_Quiet(true)
			elseif param == "off" then
				AFX_Quiet(false)
			end
		elseif cmd == "reset" or cmd == "" then
			local param = words[2]
			AFX_Reset()
		end
	end
end

-- checks for afx addon messages from group channels
function AFX_OnChatMsgAddOn(prefix, text, channel, sender)
	if AFXConfig.On and AFXConfig.PlaySoundsGroup and prefix == AFX_MENU and sender ~= ME then
		if channel == "PARTY" or channel == "RAID" then
			local found, _, sound = strfind(text,"^SOUND:(.+)")
			if found and AFX_CheckSpam(sender) == false then
				AFX_PlayOther(sender, sound)
			else
				if text == "QUIET" then
					sendGroupLocker = sender
					if IsRaidLeader() or IsRaidOfficer() or IsPartyLeader() then
						AFX_Print(format(AFX_MSG_QUIET_ON,sender,sender))
					end
				elseif text == "NOQUIET" then
					sendGroupLocker = ""
					if IsRaidLeader() or IsRaidOfficer() or IsPartyLeader() then
						AFX_Print(format(AFX_MSG_QUIET_OFF,sender,sender))
					end
				end
			end
		end
	end
end

-- checks for group status
function AFX_OnPartyMembersChanged()
	if UnitInRaid("player") then
		AFX_CheckUnlock()
	elseif UnitInParty("player") then
		AFX_CheckUnlock()
	else
		sendGroupLocker = ""
		receiveLog = {}
		return
	end

end

-- silence the group by turn off sendgroup of raid/party members and lock it
function AFX_Quiet(mode)
	local channel = ""
	if IsRaidLeader() or IsRaidOfficer() then
		channel = "RAID"
	elseif IsPartyLeader() then
		channel = "PARTY"
	else 
		AFX_Print(AFX_MSG_LEADERONLY..AFX_ON)
		return
	end
	if mode then
		sendGroupLocker = ME
		SendAddonMessage(AFX_MENU, "QUIET", channel)
		AFX_Print(AFX_LBL_QUIET..AFX_ON)
	else
		sendGroupLocker = ""
		SendAddonMessage(AFX_MENU, "NOQUIET", channel)
		AFX_Print(AFX_LBL_QUIET..AFX_OFF)
	end
end

-- check if grouped and updates locked setting
function AFX_CheckUnlock()
	-- unlock if player not in grp
	local party, members = "", 0
	if UnitInRaid("player") then
		members = GetNumRaidMembers()
		party = "raid"
	elseif UnitInParty("player") then
		members = GetNumPartyMembers()
		party = "party"
	else
		return
	end
	-- unlock if locker not in grp
	local lockerInGroup = false
	for i=1,members do
		local name = UnitName(party..i)
		if name and strlower(name) == strlower(sendGroupLocker) then
			lockerInGroup = true
			break
		end
	end
	if not lockerInGroup then
		sendGroupLocker = ""
	end
end

function AFX_Activate(mode)
	if mode then
		AFXFrame:RegisterEvent("PARTY_MEMBERS_CHANGED")
		AFXFrame:RegisterEvent("CHAT_MSG_ADDON")
		AFXConfig.On = true
		AFX_Print(AFX_LBL_ACTIVATE..AFX_ON)
	else
		AFXFrame:UnregisterEvent("PARTY_MEMBERS_CHANGED")
		AFXFrame:UnregisterEvent("CHAT_MSG_ADDON")
		AFXConfig.On = false
		AFX_Print(AFX_LBL_ACTIVATE..AFX_OFF)
	end
end

function AFX_Reset(level)
	AFXConfig = {
		["On"] = true,
		["PlaySoundsGroup"] = true,
		["SendSoundsGroup"] = true,
		["CheckDistance"] = 1, -- 0"] = Ignore, 1"] = Inspect, 30 yards or 2"] = Trade, 11.11 yards or 3"] = Duel, 10 yards or 4"] = Follow, ~28 yards
		["Verbose"] = false,
		["Debug"] = false,
		["MinInterval"] = 3,
	}
	AFX_Print(AFX_MSG_RESET)
end

-- sends sound generated to others in group
function AFX_SendSound(x)
	if AFXConfig.SendSoundsGroup and sendGroupLocker == "" then
		if UnitInRaid("player") then
			SendAddonMessage(AFX_MENU, "SOUND:"..x, "RAID")
		elseif UnitInParty("player") then
			SendAddonMessage(AFX_MENU, "SOUND:"..x, "PARTY")
		end
	end
end

-- plays sounds generated by self and send it to others in group
-- e.g. /script AFX_Play(1) or /script AFX_Play("Sound\\Spells\\PolyMorphPig.wav")
function AFX_Play(x)
	local now = GetTime()
	if AFXConfig.On and now >= lastSoundEvent then
		AFX_PlaySound(x)
		AFX_SendSound(x)
		lastSoundEvent = now + AFXConfig.MinInterval
	end
end

-- plays sounds generated by others in group
function AFX_PlayOther(sender, sound)
	-- play sound if sender is within distance
	local playSound = false
	if AFXConfig.CheckDistance > 0 then
		local party, members = "", 0
		if UnitInRaid("player") then
			members = GetNumRaidMembers()
			party = "raid"
		elseif UnitInParty("player") then
			members = GetNumPartyMembers()
			party = "party"
		else
			return
		end
		for i=1,members do
			local name = UnitName(party..i)
			if name and strlower(name) == strlower(sender) and CheckInteractDistance(party..i, AFXConfig.CheckDistance) then
				playSound = true
				break
			end
		end
	else
		playSound = true
	end
	if playSound then
		if AFXConfig.Verbose then
			AFX_Print(format(AFX_MSG_PLAYGROUP_NOTIFY,sender,sender,sound))
		end
		AFX_PlaySound(sound)
	end
end

-- actually plays sounds (either pathname or if its a number, looks up sound library)
function AFX_PlaySound(x)
	local soundIndex = tonumber(x)
	if soundIndex then
		local sound = AFX_SOUNDLIB[soundIndex]
		if sound then
			PlaySound("igMiniMapZoomIn"); 
			PlaySoundFile(sound)
		end
	else
		PlaySound("igMiniMapZoomIn"); 
		PlaySoundFile(x)
	end
end

-- search and display results in frame a list of matching sounds and their respective indices
function AFX_Search(x)
	if type(x) == "string" then
		x = strlower(strtrim(x))
		if x ~= "" then
			local f = getglobal("AFXSearchFrame")
			if f:IsVisible() then
				AFXSearchFrameScrollFrameScrollChildText:SetText("")
				AFXSearchFrameScrollFrameScrollBar:SetValue(0)
				AFXSearchFrameScrollFrame:UpdateScrollChildRect()
			end
			local found = 0
			local results = ""
			for i=1, #(AFX_SOUNDLIB) do
				if strfind(strlower(AFX_SOUNDLIB[i]), x, 1, true) then
					found = found + 1
					results = results .. "["..i.."] "..AFX_SOUNDLIB[i] .. "\n"
				end
			end
			if found > 0 then
				AFXSearchFrameScrollFrameScrollChildText:SetText(results)
				AFXSearchFrameScrollFrameScrollBar:SetValue(0)
				AFXSearchFrameScrollFrame:UpdateScrollChildRect()
				f:Show()
			end
		end
	end
end

-- ===================
-- ANTI SPAM FUNCTIONS
-- ===================

-- check time of last sound event and return true if its spam
function AFX_CheckSpam(sender)
	local now = GetTime()
	local senderIndex = 0
	local isSpam = false
	for i=1, #(receiveLog) do
		if receiveLog[i].name == sender then
			senderIndex = i
			if now <= receiveLog[i].time then
				isSpam = true
			end
			break
		end
	end
	if senderIndex == 0 then
		local message = {}
		message.sender = sender
		message.time = now + AFXConfig.MinInterval
		tinsert(receiveLog, message)
	elseif isSpam == false then
		receiveLog[i].time = now + AFXConfig.MinInterval
	end
	return isSpam
end

-- ===============
-- MISC FUNCTIONS 
-- ===============

function AFX_Print(x, r, g, b)
	x = "|cFFFFFF99"..AFX_MENU..":|r "..x
	DEFAULT_CHAT_FRAME:AddMessage(x, r, g, b)
end

function AFX_Error(x)
	if AFXConfig.Debug then
		UIErrorsFrame:AddMessage(x, 1, 1, 0, 0, 3)
	end
end

function AFX_Strip(x, y)
	local p, n = strfind(strlower(strtrim(x)), strlower(y), 1, true)
	if p and p == 1 and n then
		return strtrim(strsub(x, n+1, strlen(x)))
	end
	return nil
end

-- Split a string into an array of strings by specified delimiter
function AFX_Split(text,separator)
	if type(text) ~= "string" or text == "" then
		return {}
	else
		if strfind(text,separator) then
			return { strsplit(separator,text) }
		else
			return { text }
		end
	end
end
